| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Enumerations | Functions
CDC Class Host Mode Driver
CDC-ACM (Virtual Serial) Class Driver

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LPCUSBlib/Drivers/USB/Class/Host/CDC.c (Makefile source module name: LPCUSBlib_SRC_USBCLASS)

# Module Description

Host Mode USB Class driver framework interface, for the CDC USB Class driver.

## Data Structures
struct | USB_ClassInfo_CDC_Host_t
| CDC Class Host Mode Configuration and State Structure. More...

## Enumerations
enum | CDC_Host_EnumerationFailure_ErrorCodes_t { CDC_ENUMERROR_NoError = 0, CDC_ENUMERROR_InvalidConfigDescriptor = 1, CDC_ENUMERROR_NoCompatibleInterfaceFound = 2, CDC_ENUMERROR_PipeConfigurationFailed = 3 }

## Functions
void | CDC_Host_USBTask (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| General management task for a given CDC host class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().
uint8_t | CDC_Host_ConfigurePipes (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, uint16_t ConfigDescriptorSize, void *DeviceConfigDescriptor) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(3)
| Host interface configuration routine, to configure a given CDC host interface instance using the Configuration Descriptor read from an attached USB device. This function automatically updates the given CDC Host instance's state values and configures the pipes required to communicate with the interface if it is found within the device. This should be called once after the stack has enumerated the attached device, while the host state machine is in the Addressed state.
uint8_t | CDC_Host_SetLineEncoding (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Sets the line encoding for the attached device's virtual serial port. This should be called when the `LineEncoding` values of the interface have been changed to push the new settings to the USB device.
uint8_t | CDC_Host_SendControlLineStateChange (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Sends a Serial Control Line State Change notification to the device. This should be called when the virtual serial control lines (DTR, RTS, etc.) have changed states. Line states persist until they are cleared via a second notification. This should be called each time the CDC class driver's `ControlLineStates.HostToDevice` value is updated to push the new states to the USB device.
uint8_t | CDC_Host_SendBreak (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, const uint8_t Duration) ATTR_NON_NULL_PTR_ARG(1)
| Sends a Send Break request to the device. This is generally used to separate data or to indicate a special condition to the receiving device.
uint8_t | CDC_Host_SendData (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, const uint8_t *const Buffer, const uint16_t Length)
| Sends a given data buffer to the attached USB device, if connected. If a device is not connected when the function is called, the data will be discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the CDC_Host_Flush() function is called to flush the pending data to the device. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.
uint8_t | CDC_Host_SendString (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, const char *const String) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
| Sends a given null-terminated string to the attached USB device, if connected. If a device is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the CDC_Host_Flush() function is called to flush the pending data to the device. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.
uint8_t | CDC_Host_SendByte (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, const uint8_t Data) ATTR_NON_NULL_PTR_ARG(1)
| Sends a given byte to the attached USB device, if connected. If a device is not connected when the function is called, the byte is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the CDC_Host_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.
uint16_t | CDC_Host_BytesReceived (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Determines the number of bytes received by the CDC interface from the device, waiting to be read. This indicates the number of bytes in the IN pipe bank only, and thus the number of calls to CDC_Host_ReceiveByte() which are guaranteed to succeed immediately. If multiple bytes are to be received, they should be buffered by the user application, as the pipe bank will not be released back to the USB controller until all bytes are read.
int16_t | CDC_Host_ReceiveByte (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Reads a byte of data from the device. If no data is waiting to be read of if a USB device is not connected, the function returns a negative value. The CDC_Host_BytesReceived() function may be queried in advance to determine how many bytes are currently buffered in the CDC interface's data receive pipe.
uint8_t | CDC_Host_Flush (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Flushes any data waiting to be sent, ensuring that the send buffer is cleared.
void | CDC_Host_CreateStream (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, FILE *const Stream)
| Creates a standard character stream for the given CDC Device instance so that it can be used with all the regular functions in the standard `<stdio.h>` library that accept a `FILE` stream as a destination (e.g. `fprintf`). The created stream is bidirectional and can be used for both input and output functions.
void | CDC_Host_CreateBlockingStream (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo, FILE *const Stream)
| Identical to CDC_Host_CreateStream(), except that reads are blocking until the calling stream function terminates the transfer. While blocking, the USB and CDC service tasks are called repeatedly to maintain USB communications.
void | EVENT_CDC_Host_ControLineStateChanged (USB_ClassInfo_CDC_Host_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| CDC class driver event for a control line state change on a CDC host interface. This event fires each time the device notifies the host of a control line state change (containing the virtual serial control line states, such as DCD) and may be hooked in the user program by declaring a handler function with the same name and parameters listed here. The new control line states are available in the ControlLineStates.DeviceToHost value inside the CDC host interface structure passed as a parameter, set as a mask of `CDC_CONTROL_LINE_IN_*` masks.

## Enumeration Type Documentation

enum CDC_Host_EnumerationFailure_ErrorCodes_t

Enum for the possible error codes returned by the CDC_Host_ConfigurePipes() function.

Enumerator:

  CDC_ENUMERROR_NoError | Configuration Descriptor was processed successfully.
  CDC_ENUMERROR_InvalidConfigDescriptor | The device returned an invalid Configuration Descriptor.
  CDC_ENUMERROR_NoCompatibleInterfaceFound | A compatible CDC interface was not found in the device's Configuration Descriptor.
  CDC_ENUMERROR_PipeConfigurationFailed | One or more pipes for the specified interface could not be configured correctly.

Definition at line 128 of file CDCClassHost.h.

## Function Documentation

uint16_t CDC_Host_BytesReceived | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

Determines the number of bytes received by the CDC interface from the device, waiting to be read. This indicates the number of bytes in the IN pipe bank only, and thus the number of calls to CDC_Host_ReceiveByte() which are guaranteed to succeed immediately. If multiple bytes are to be received, they should be buffered by the user application, as the pipe bank will not be released back to the USB controller until all bytes are read.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.

Returns
  Total number of buffered bytes received from the device.

Definition at line 388 of file CDCClassHost.c.

uint8_t CDC_Host_ConfigurePipes | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | uint16_t | ConfigDescriptorSize,
|  | void * | DeviceConfigDescriptor
| ) |  |

Host interface configuration routine, to configure a given CDC host interface instance using the Configuration Descriptor read from an attached USB device. This function automatically updates the given CDC Host instance's state values and configures the pipes required to communicate with the interface if it is found within the device. This should be called once after the stack has enumerated the attached device, while the host state machine is in the Addressed state.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing an CDC Class host configuration and state.
  ConfigDescriptorSize | : Length of the attached device's Configuration Descriptor.
  DeviceConfigDescriptor | : Pointer to a buffer containing the attached device's Configuration Descriptor.

Returns
  A value from the CDC_Host_EnumerationFailure_ErrorCodes_t enum.

Definition at line 43 of file CDCClassHost.c.

void CDC_Host_CreateBlockingStream | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Identical to CDC_Host_CreateStream(), except that reads are blocking until the calling stream function terminates the transfer. While blocking, the USB and CDC service tasks are called repeatedly to maintain USB communications.

Note
  This function is not available on all microcontroller architectures.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class configuration and state.
  Stream | : Pointer to a FILE structure where the created stream should be placed.

Returns
  Nothing

void CDC_Host_CreateStream | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Creates a standard character stream for the given CDC Device instance so that it can be used with all the regular functions in the standard `<stdio.h>` library that accept a `FILE` stream as a destination (e.g. `fprintf`). The created stream is bidirectional and can be used for both input and output functions.

Reading data from this stream is non-blocking, i.e. in most instances, complete strings cannot be read in by a single fetch, as the endpoint will not be ready at some point in the transmission, aborting the transfer. However, this may be used when the read data is processed byte-per-bye (via `getc()`) or when the user application will implement its own line buffering.

Note
  The created stream can be given as stdout if desired to direct the standard output from all `<stdio.h>` functions to the given CDC interface.
  This function is not available on all microcontroller architectures.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class configuration and state.
  Stream | : Pointer to a FILE structure where the created stream should be placed.

Returns
  Nothing

uint8_t CDC_Host_Flush | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

Flushes any data waiting to be sent, ensuring that the send buffer is cleared.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.

Definition at line 445 of file CDCClassHost.c.

int16_t CDC_Host_ReceiveByte | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

Reads a byte of data from the device. If no data is waiting to be read of if a USB device is not connected, the function returns a negative value. The CDC_Host_BytesReceived() function may be queried in advance to determine how many bytes are currently buffered in the CDC interface's data receive pipe.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.

Returns
  Next received byte from the device, or a negative value if no data received.

Definition at line 420 of file CDCClassHost.c.

uint8_t CDC_Host_SendBreak | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | const uint8_t | Duration
| ) |  |

Sends a Send Break request to the device. This is generally used to separate data or to indicate a special condition to the receiving device.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.
  Duration | : Duration of the break, in milliseconds.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum.

Definition at line 307 of file CDCClassHost.c.

uint8_t CDC_Host_SendByte | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | const uint8_t | Data
| ) |  |

Sends a given byte to the attached USB device, if connected. If a device is not connected when the function is called, the byte is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the CDC_Host_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.
  Data | : Byte of data to send to the device.

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.

Definition at line 362 of file CDCClassHost.c.

uint8_t CDC_Host_SendControlLineStateChange | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

Sends a Serial Control Line State Change notification to the device. This should be called when the virtual serial control lines (DTR, RTS, etc.) have changed states. Line states persist until they are cleared via a second notification. This should be called each time the CDC class driver's `ControlLineStates.HostToDevice` value is updated to push the new states to the USB device.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum.

Definition at line 290 of file CDCClassHost.c.

uint8_t CDC_Host_SendData | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | const uint8_t *const | Buffer,
|  | const uint16_t | Length
| ) |  |

Sends a given data buffer to the attached USB device, if connected. If a device is not connected when the function is called, the data will be discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the CDC_Host_Flush() function is called to flush the pending data to the device. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.
  Buffer | : Pointer to a buffer containing the data to send to the device.
  Length | : Length of the data to send to the device.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

Definition at line 325 of file CDCClassHost.c.

uint8_t CDC_Host_SendString | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo,
|  | const char *const | String
| ) |  |

Sends a given null-terminated string to the attached USB device, if connected. If a device is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the CDC_Host_Flush() function is called to flush the pending data to the device. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.
  String | : Pointer to the null terminated string to send to the device.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

Definition at line 344 of file CDCClassHost.c.

uint8_t CDC_Host_SetLineEncoding | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

Sets the line encoding for the attached device's virtual serial port. This should be called when the `LineEncoding` values of the interface have been changed to push the new settings to the USB device.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum.

Definition at line 273 of file CDCClassHost.c.

void CDC_Host_USBTask | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

General management task for a given CDC host class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing an CDC Class host configuration and state.

Returns
  Nothing

Definition at line 233 of file CDCClassHost.c.

void EVENT_CDC_Host_ControLineStateChanged | ( | USB_ClassInfo_CDC_Host_t *const | CDCInterfaceInfo | ) |

CDC class driver event for a control line state change on a CDC host interface. This event fires each time the device notifies the host of a control line state change (containing the virtual serial control line states, such as DCD) and may be hooked in the user program by declaring a handler function with the same name and parameters listed here. The new control line states are available in the ControlLineStates.DeviceToHost value inside the CDC host interface structure passed as a parameter, set as a mask of `CDC_CONTROL_LINE_IN_*` masks.

Parameters

  CDCInterfaceInfo | : Pointer to a structure containing a CDC Class host configuration and state.

Returns
  Nothing